// $ANTLR 3.1 ..\\antlrEMSIV\\src\\EMS.g 2015-12-04 17:45:01

package com.pbsage.parser.emsiv;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;


import org.antlr.runtime.tree.*;

public class EMSParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "NEWLINE", "NUMBER", "ID", "F1", "F2", "'+'", "'-'", "'*'", "'/'", "'('", "')'", "','"
    };
    public static final int T__15=15;
    public static final int NEWLINE=4;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int T__10=10;
    public static final int NUMBER=5;
    public static final int F1=7;
    public static final int F2=8;
    public static final int ID=6;
    public static final int EOF=-1;
    public static final int T__9=9;

    // delegates
    // delegators


        public EMSParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public EMSParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return EMSParser.tokenNames; }
    public String getGrammarFileName() { return "..\\antlrEMSIV\\src\\EMS.g"; }


    public static class prog_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prog"
    // ..\\antlrEMSIV\\src\\EMS.g:16:1: prog : expr NEWLINE ;
    public final EMSParser.prog_return prog() throws RecognitionException {
        EMSParser.prog_return retval = new EMSParser.prog_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token NEWLINE2=null;
        EMSParser.expr_return expr1 = null;


        CommonTree NEWLINE2_tree=null;

        try {
            // ..\\antlrEMSIV\\src\\EMS.g:17:2: ( expr NEWLINE )
            // ..\\antlrEMSIV\\src\\EMS.g:17:4: expr NEWLINE
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_expr_in_prog46);
            expr1=expr();

            state._fsp--;

            adaptor.addChild(root_0, expr1.getTree());
            NEWLINE2=(Token)match(input,NEWLINE,FOLLOW_NEWLINE_in_prog48); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prog"

    public static class expr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expr"
    // ..\\antlrEMSIV\\src\\EMS.g:20:1: expr : multExpr ( ( '+' | '-' ) multExpr )* ;
    public final EMSParser.expr_return expr() throws RecognitionException {
        EMSParser.expr_return retval = new EMSParser.expr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token char_literal4=null;
        Token char_literal5=null;
        EMSParser.multExpr_return multExpr3 = null;

        EMSParser.multExpr_return multExpr6 = null;


        CommonTree char_literal4_tree=null;
        CommonTree char_literal5_tree=null;

        try {
            // ..\\antlrEMSIV\\src\\EMS.g:21:2: ( multExpr ( ( '+' | '-' ) multExpr )* )
            // ..\\antlrEMSIV\\src\\EMS.g:21:4: multExpr ( ( '+' | '-' ) multExpr )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_multExpr_in_expr60);
            multExpr3=multExpr();

            state._fsp--;

            adaptor.addChild(root_0, multExpr3.getTree());
            // ..\\antlrEMSIV\\src\\EMS.g:21:13: ( ( '+' | '-' ) multExpr )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( ((LA2_0>=9 && LA2_0<=10)) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // ..\\antlrEMSIV\\src\\EMS.g:21:14: ( '+' | '-' ) multExpr
            	    {
            	    // ..\\antlrEMSIV\\src\\EMS.g:21:14: ( '+' | '-' )
            	    int alt1=2;
            	    int LA1_0 = input.LA(1);

            	    if ( (LA1_0==9) ) {
            	        alt1=1;
            	    }
            	    else if ( (LA1_0==10) ) {
            	        alt1=2;
            	    }
            	    else {
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 1, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt1) {
            	        case 1 :
            	            // ..\\antlrEMSIV\\src\\EMS.g:21:15: '+'
            	            {
            	            char_literal4=(Token)match(input,9,FOLLOW_9_in_expr64); 
            	            char_literal4_tree = (CommonTree)adaptor.create(char_literal4);
            	            root_0 = (CommonTree)adaptor.becomeRoot(char_literal4_tree, root_0);


            	            }
            	            break;
            	        case 2 :
            	            // ..\\antlrEMSIV\\src\\EMS.g:21:20: '-'
            	            {
            	            char_literal5=(Token)match(input,10,FOLLOW_10_in_expr67); 
            	            char_literal5_tree = (CommonTree)adaptor.create(char_literal5);
            	            root_0 = (CommonTree)adaptor.becomeRoot(char_literal5_tree, root_0);


            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_multExpr_in_expr71);
            	    multExpr6=multExpr();

            	    state._fsp--;

            	    adaptor.addChild(root_0, multExpr6.getTree());

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "expr"

    public static class multExpr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multExpr"
    // ..\\antlrEMSIV\\src\\EMS.g:24:1: multExpr : atom ( ( '*' | '/' ) atom )* ;
    public final EMSParser.multExpr_return multExpr() throws RecognitionException {
        EMSParser.multExpr_return retval = new EMSParser.multExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token char_literal8=null;
        Token char_literal9=null;
        EMSParser.atom_return atom7 = null;

        EMSParser.atom_return atom10 = null;


        CommonTree char_literal8_tree=null;
        CommonTree char_literal9_tree=null;

        try {
            // ..\\antlrEMSIV\\src\\EMS.g:25:2: ( atom ( ( '*' | '/' ) atom )* )
            // ..\\antlrEMSIV\\src\\EMS.g:25:4: atom ( ( '*' | '/' ) atom )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_atom_in_multExpr85);
            atom7=atom();

            state._fsp--;

            adaptor.addChild(root_0, atom7.getTree());
            // ..\\antlrEMSIV\\src\\EMS.g:25:9: ( ( '*' | '/' ) atom )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( ((LA4_0>=11 && LA4_0<=12)) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // ..\\antlrEMSIV\\src\\EMS.g:25:10: ( '*' | '/' ) atom
            	    {
            	    // ..\\antlrEMSIV\\src\\EMS.g:25:10: ( '*' | '/' )
            	    int alt3=2;
            	    int LA3_0 = input.LA(1);

            	    if ( (LA3_0==11) ) {
            	        alt3=1;
            	    }
            	    else if ( (LA3_0==12) ) {
            	        alt3=2;
            	    }
            	    else {
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 3, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt3) {
            	        case 1 :
            	            // ..\\antlrEMSIV\\src\\EMS.g:25:11: '*'
            	            {
            	            char_literal8=(Token)match(input,11,FOLLOW_11_in_multExpr89); 
            	            char_literal8_tree = (CommonTree)adaptor.create(char_literal8);
            	            root_0 = (CommonTree)adaptor.becomeRoot(char_literal8_tree, root_0);


            	            }
            	            break;
            	        case 2 :
            	            // ..\\antlrEMSIV\\src\\EMS.g:25:16: '/'
            	            {
            	            char_literal9=(Token)match(input,12,FOLLOW_12_in_multExpr92); 
            	            char_literal9_tree = (CommonTree)adaptor.create(char_literal9);
            	            root_0 = (CommonTree)adaptor.becomeRoot(char_literal9_tree, root_0);


            	            }
            	            break;

            	    }

            	    pushFollow(FOLLOW_atom_in_multExpr96);
            	    atom10=atom();

            	    state._fsp--;

            	    adaptor.addChild(root_0, atom10.getTree());

            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multExpr"

    public static class atom_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "atom"
    // ..\\antlrEMSIV\\src\\EMS.g:28:1: atom : ( NUMBER | ID | func | '(' expr ')' );
    public final EMSParser.atom_return atom() throws RecognitionException {
        EMSParser.atom_return retval = new EMSParser.atom_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token NUMBER11=null;
        Token ID12=null;
        Token char_literal14=null;
        Token char_literal16=null;
        EMSParser.func_return func13 = null;

        EMSParser.expr_return expr15 = null;


        CommonTree NUMBER11_tree=null;
        CommonTree ID12_tree=null;
        CommonTree char_literal14_tree=null;
        CommonTree char_literal16_tree=null;

        try {
            // ..\\antlrEMSIV\\src\\EMS.g:29:2: ( NUMBER | ID | func | '(' expr ')' )
            int alt5=4;
            switch ( input.LA(1) ) {
            case NUMBER:
                {
                alt5=1;
                }
                break;
            case ID:
                {
                alt5=2;
                }
                break;
            case F1:
            case F2:
                {
                alt5=3;
                }
                break;
            case 13:
                {
                alt5=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }

            switch (alt5) {
                case 1 :
                    // ..\\antlrEMSIV\\src\\EMS.g:29:4: NUMBER
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    NUMBER11=(Token)match(input,NUMBER,FOLLOW_NUMBER_in_atom110); 
                    NUMBER11_tree = (CommonTree)adaptor.create(NUMBER11);
                    adaptor.addChild(root_0, NUMBER11_tree);


                    }
                    break;
                case 2 :
                    // ..\\antlrEMSIV\\src\\EMS.g:30:4: ID
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    ID12=(Token)match(input,ID,FOLLOW_ID_in_atom116); 
                    ID12_tree = (CommonTree)adaptor.create(ID12);
                    adaptor.addChild(root_0, ID12_tree);


                    }
                    break;
                case 3 :
                    // ..\\antlrEMSIV\\src\\EMS.g:31:4: func
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_func_in_atom121);
                    func13=func();

                    state._fsp--;

                    adaptor.addChild(root_0, func13.getTree());

                    }
                    break;
                case 4 :
                    // ..\\antlrEMSIV\\src\\EMS.g:32:4: '(' expr ')'
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    char_literal14=(Token)match(input,13,FOLLOW_13_in_atom126); 
                    pushFollow(FOLLOW_expr_in_atom129);
                    expr15=expr();

                    state._fsp--;

                    adaptor.addChild(root_0, expr15.getTree());
                    char_literal16=(Token)match(input,14,FOLLOW_14_in_atom131); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "atom"

    public static class func_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "func"
    // ..\\antlrEMSIV\\src\\EMS.g:35:1: func : ( F1 '(' expr ')' | F2 '(' expr ',' expr ')' );
    public final EMSParser.func_return func() throws RecognitionException {
        EMSParser.func_return retval = new EMSParser.func_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token F117=null;
        Token char_literal18=null;
        Token char_literal20=null;
        Token F221=null;
        Token char_literal22=null;
        Token char_literal24=null;
        Token char_literal26=null;
        EMSParser.expr_return expr19 = null;

        EMSParser.expr_return expr23 = null;

        EMSParser.expr_return expr25 = null;


        CommonTree F117_tree=null;
        CommonTree char_literal18_tree=null;
        CommonTree char_literal20_tree=null;
        CommonTree F221_tree=null;
        CommonTree char_literal22_tree=null;
        CommonTree char_literal24_tree=null;
        CommonTree char_literal26_tree=null;

        try {
            // ..\\antlrEMSIV\\src\\EMS.g:36:2: ( F1 '(' expr ')' | F2 '(' expr ',' expr ')' )
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==F1) ) {
                alt6=1;
            }
            else if ( (LA6_0==F2) ) {
                alt6=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }
            switch (alt6) {
                case 1 :
                    // ..\\antlrEMSIV\\src\\EMS.g:36:4: F1 '(' expr ')'
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    F117=(Token)match(input,F1,FOLLOW_F1_in_func143); 
                    F117_tree = (CommonTree)adaptor.create(F117);
                    root_0 = (CommonTree)adaptor.becomeRoot(F117_tree, root_0);

                    char_literal18=(Token)match(input,13,FOLLOW_13_in_func146); 
                    pushFollow(FOLLOW_expr_in_func149);
                    expr19=expr();

                    state._fsp--;

                    adaptor.addChild(root_0, expr19.getTree());
                    char_literal20=(Token)match(input,14,FOLLOW_14_in_func151); 

                    }
                    break;
                case 2 :
                    // ..\\antlrEMSIV\\src\\EMS.g:37:4: F2 '(' expr ',' expr ')'
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    F221=(Token)match(input,F2,FOLLOW_F2_in_func157); 
                    F221_tree = (CommonTree)adaptor.create(F221);
                    root_0 = (CommonTree)adaptor.becomeRoot(F221_tree, root_0);

                    char_literal22=(Token)match(input,13,FOLLOW_13_in_func160); 
                    pushFollow(FOLLOW_expr_in_func163);
                    expr23=expr();

                    state._fsp--;

                    adaptor.addChild(root_0, expr23.getTree());
                    char_literal24=(Token)match(input,15,FOLLOW_15_in_func165); 
                    pushFollow(FOLLOW_expr_in_func168);
                    expr25=expr();

                    state._fsp--;

                    adaptor.addChild(root_0, expr25.getTree());
                    char_literal26=(Token)match(input,14,FOLLOW_14_in_func170); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "func"

    // Delegated rules


 

    public static final BitSet FOLLOW_expr_in_prog46 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_NEWLINE_in_prog48 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multExpr_in_expr60 = new BitSet(new long[]{0x0000000000000602L});
    public static final BitSet FOLLOW_9_in_expr64 = new BitSet(new long[]{0x00000000000021E0L});
    public static final BitSet FOLLOW_10_in_expr67 = new BitSet(new long[]{0x00000000000021E0L});
    public static final BitSet FOLLOW_multExpr_in_expr71 = new BitSet(new long[]{0x0000000000000602L});
    public static final BitSet FOLLOW_atom_in_multExpr85 = new BitSet(new long[]{0x0000000000001802L});
    public static final BitSet FOLLOW_11_in_multExpr89 = new BitSet(new long[]{0x00000000000021E0L});
    public static final BitSet FOLLOW_12_in_multExpr92 = new BitSet(new long[]{0x00000000000021E0L});
    public static final BitSet FOLLOW_atom_in_multExpr96 = new BitSet(new long[]{0x0000000000001802L});
    public static final BitSet FOLLOW_NUMBER_in_atom110 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_atom116 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_func_in_atom121 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_13_in_atom126 = new BitSet(new long[]{0x00000000000021E0L});
    public static final BitSet FOLLOW_expr_in_atom129 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_14_in_atom131 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F1_in_func143 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_func146 = new BitSet(new long[]{0x00000000000021E0L});
    public static final BitSet FOLLOW_expr_in_func149 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_14_in_func151 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F2_in_func157 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_func160 = new BitSet(new long[]{0x00000000000021E0L});
    public static final BitSet FOLLOW_expr_in_func163 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_15_in_func165 = new BitSet(new long[]{0x00000000000021E0L});
    public static final BitSet FOLLOW_expr_in_func168 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_14_in_func170 = new BitSet(new long[]{0x0000000000000002L});

}