package com.pbsage.parser.emsiv;

import lombok.extern.slf4j.Slf4j;

import java.lang.reflect.Method;
@Slf4j
public class FunctionUtil {

	public static double compute(String function, double a) {
		double result = 0.0;
		Class<?> mathClass = Math.class;
		try {
			Method method = mathClass.getMethod(function,
					new Class[] { double.class });
			result = (Double) method.invoke(mathClass, new Object[] { a });
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return result;
	}

	public static double compute(String function, double a, double b) {
		double result = 0.0;
		Class<?> mathClass = Math.class;
		try {
			Method method = mathClass.getMethod(function, new Class[] {
					double.class, double.class });
			result = (Double) method.invoke(mathClass, new Object[] { a, b });
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return result;
	}
}
