package com.persagy.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "EntityDynamicDataArray")
public class EntityDynamicDataArray {
	public EntityDynamicDataArray() {

	}

	public EntityDynamicDataArray(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	EntityDynamicData[] dataArray;

	public EntityDynamicData[] getDataArray() {
		return dataArray;
	}

	public void setDataArray(EntityDynamicData[] dataArray) {
		this.dataArray = dataArray;
	}
}
