package com.persagy.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "EntitySimple")
public class EntitySimple {
	public EntitySimple() {

	}

	public EntitySimple(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	Long id;
	String name;
	Double data;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Double getData() {
		return data;
	}

	public void setData(Double data) {
		this.data = data;
	}

}
