package com.persagy.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "WSBatchItem")
public class WSBatchItem {
	public WSBatchItem() {

	}

	public WSBatchItem(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String meter;// command=data_near/flag_near/data_service/write_fjd_flag
	Long funcid;// command=data_near/flag_near/data_service/write_fjd_flag
	String energyModelSign;// command=data_energy
	String energyModelNodeSign;// command=data_energy
	String time_period;// command=data_near/flag_near/data_service/data_energy
	String data_time_from;// command=data_near/flag_near/data_service/data_energy
	String data_time_to;// command=data_near/flag_near/data_service/data_energy
	WSFlag[] flags;// command=flag_near/write_fjd_flag
	WSData[] datas;// command=data_near/data_service/data_energy

	public String getMeter() {
		return meter;
	}

	public void setMeter(String meter) {
		this.meter = meter;
	}

	public Long getFuncid() {
		return funcid;
	}

	public void setFuncid(Long funcid) {
		this.funcid = funcid;
	}

	public String getEnergyModelSign() {
		return energyModelSign;
	}

	public void setEnergyModelSign(String energyModelSign) {
		this.energyModelSign = energyModelSign;
	}

	public String getEnergyModelNodeSign() {
		return energyModelNodeSign;
	}

	public void setEnergyModelNodeSign(String energyModelNodeSign) {
		this.energyModelNodeSign = energyModelNodeSign;
	}

	public String getTime_period() {
		return time_period;
	}

	public void setTime_period(String time_period) {
		this.time_period = time_period;
	}

	public String getData_time_from() {
		return data_time_from;
	}

	public void setData_time_from(String data_time_from) {
		this.data_time_from = data_time_from;
	}

	public String getData_time_to() {
		return data_time_to;
	}

	public void setData_time_to(String data_time_to) {
		this.data_time_to = data_time_to;
	}

	public WSFlag[] getFlags() {
		return flags;
	}

	public void setFlags(WSFlag[] flags) {
		this.flags = flags;
	}

	public WSData[] getDatas() {
		return datas;
	}

	public void setDatas(WSData[] datas) {
		this.datas = datas;
	}

}
