package com.persagy.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "WSBatchParam")
public class WSBatchParam {
	public WSBatchParam() {

	}

	public WSBatchParam(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String command;
	String building;// command=data_near/flag_near/data_service/data_energy/write_fjd_flag
	Long compute_round;// write_fjd_flag
	WSBatchItem[] items;

	public String getCommand() {
		return command;
	}

	public void setCommand(String command) {
		this.command = command;
	}

	public String getBuilding() {
		return building;
	}

	public void setBuilding(String building) {
		this.building = building;
	}

	public Long getCompute_round() {
		return compute_round;
	}

	public void setCompute_round(Long compute_round) {
		this.compute_round = compute_round;
	}

	public WSBatchItem[] getItems() {
		return items;
	}

	public void setItems(WSBatchItem[] items) {
		this.items = items;
	}
}
