package com.persagy.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "WSData")
public class WSData {
	public WSData() {

	}

	public WSData(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String data_time;
	Double data_value;
	String label_flag;
	String data_from;

	public String getData_time() {
		return data_time;
	}

	public void setData_time(String data_time) {
		this.data_time = data_time;
	}

	public Double getData_value() {
		return data_value;
	}

	public void setData_value(Double data_value) {
		this.data_value = data_value;
	}

	public String getLabel_flag() {
		return label_flag;
	}

	public void setLabel_flag(String label_flag) {
		this.label_flag = label_flag;
	}

	public String getData_from() {
		return data_from;
	}

	public void setData_from(String data_from) {
		this.data_from = data_from;
	}
}
