package com.persagy.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "WSEntity_report_change")
public class WSEntity_report_change {
	public WSEntity_report_change() {

	}

	public WSEntity_report_change(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String building;
	String meter;
	Long funcid;
	String operation;
	String receivetime;
	Double data_old;
	Double data_new;

	public Double getData_old() {
		return data_old;
	}

	public void setData_old(Double data_old) {
		this.data_old = data_old;
	}

	public Double getData_new() {
		return data_new;
	}

	public void setData_new(Double data_new) {
		this.data_new = data_new;
	}

	public String getBuilding() {
		return building;
	}

	public void setBuilding(String building) {
		this.building = building;
	}

	public String getMeter() {
		return meter;
	}

	public void setMeter(String meter) {
		this.meter = meter;
	}

	public Long getFuncid() {
		return funcid;
	}

	public void setFuncid(Long funcid) {
		this.funcid = funcid;
	}

	public String getOperation() {
		return operation;
	}

	public void setOperation(String operation) {
		this.operation = operation;
	}

	public String getReceivetime() {
		return receivetime;
	}

	public void setReceivetime(String receivetime) {
		this.receivetime = receivetime;
	}

}
