package com.persagy.entity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "WSEntity_tenant")
public class WSEntity_tenant {
	public WSEntity_tenant() {

	}

	public WSEntity_tenant(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String building;
	String sign;
	String valid_time_from;
	Boolean soft_enable;
	Double soft_initial_yuer;

	WSEntity_tenant_energy[] energys;

	public String getBuilding() {
		return building;
	}

	public void setBuilding(String building) {
		this.building = building;
	}

	public String getSign() {
		return sign;
	}

	public void setSign(String sign) {
		this.sign = sign;
	}

	public String getValid_time_from() {
		return valid_time_from;
	}

	public void setValid_time_from(String valid_time_from) {
		this.valid_time_from = valid_time_from;
	}

	public Boolean getSoft_enable() {
		return soft_enable;
	}

	public void setSoft_enable(Boolean soft_enable) {
		this.soft_enable = soft_enable;
	}

	public Double getSoft_initial_yuer() {
		return soft_initial_yuer;
	}

	public void setSoft_initial_yuer(Double soft_initial_yuer) {
		this.soft_initial_yuer = soft_initial_yuer;
	}

	public WSEntity_tenant_energy[] getEnergys() {
		return energys;
	}

	public void setEnergys(WSEntity_tenant_energy[] energys) {
		this.energys = energys;
	}

}
