package com.persagy.entity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "WSEntity_tenant")
public class WSEntity_tenant_energy {
	public WSEntity_tenant_energy() {

	}

	public WSEntity_tenant_energy(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String energy_type;
	String price_type;
	Boolean soft_enable;
	Double soft_initial_yuer;

	String price_content;

	WSEntity_tenant_energy_meter[] meters;

	public String getEnergy_type() {
		return energy_type;
	}

	public void setEnergy_type(String energy_type) {
		this.energy_type = energy_type;
	}

	public String getPrice_type() {
		return price_type;
	}

	public void setPrice_type(String price_type) {
		this.price_type = price_type;
	}

	public Boolean getSoft_enable() {
		return soft_enable;
	}

	public void setSoft_enable(Boolean soft_enable) {
		this.soft_enable = soft_enable;
	}

	public Double getSoft_initial_yuer() {
		return soft_initial_yuer;
	}

	public void setSoft_initial_yuer(Double soft_initial_yuer) {
		this.soft_initial_yuer = soft_initial_yuer;
	}

	public String getPrice_content() {
		return price_content;
	}

	public void setPrice_content(String price_content) {
		this.price_content = price_content;
	}

	public WSEntity_tenant_energy_meter[] getMeters() {
		return meters;
	}

	public void setMeters(WSEntity_tenant_energy_meter[] meters) {
		this.meters = meters;
	}
}
