package com.persagy.entity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "WSEntity_tenant")
public class WSEntity_tenant_energy_meter {
	public WSEntity_tenant_energy_meter() {

	}

	public WSEntity_tenant_energy_meter(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String meter_sign;
	Double share_ratio;
	Double transformer_ratio;
	WSEntity_point[] points;

	public String getMeter_sign() {
		return meter_sign;
	}

	public void setMeter_sign(String meter_sign) {
		this.meter_sign = meter_sign;
	}

	public Double getShare_ratio() {
		return share_ratio;
	}

	public void setShare_ratio(Double share_ratio) {
		this.share_ratio = share_ratio;
	}

	public Double getTransformer_ratio() {
		return transformer_ratio;
	}

	public void setTransformer_ratio(Double transformer_ratio) {
		this.transformer_ratio = transformer_ratio;
	}

	public WSEntity_point[] getPoints() {
		return points;
	}

	public void setPoints(WSEntity_point[] points) {
		this.points = points;
	}
}
