package com.persagy.entity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "WSPoint")
public class WSPoint {
	public WSPoint() {

	}

	public WSPoint(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String building;
	String meter;
	Long funcid;
	String data_type;
	String collect_cycle;
	String first_compute_time;

	public String getFirst_compute_time() {
		return first_compute_time;
	}

	public void setFirst_compute_time(String first_compute_time) {
		this.first_compute_time = first_compute_time;
	}

	public String getBuilding() {
		return building;
	}

	public void setBuilding(String building) {
		this.building = building;
	}

	public String getMeter() {
		return meter;
	}

	public void setMeter(String meter) {
		this.meter = meter;
	}

	public Long getFuncid() {
		return funcid;
	}

	public void setFuncid(Long funcid) {
		this.funcid = funcid;
	}

	public String getData_type() {
		return data_type;
	}

	public void setData_type(String data_type) {
		this.data_type = data_type;
	}

	public String getCollect_cycle() {
		return collect_cycle;
	}

	public void setCollect_cycle(String collect_cycle) {
		this.collect_cycle = collect_cycle;
	}

}
