package com.persagy.service;

import javax.jws.WebResult;
import javax.jws.WebService;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;

import com.persagy.entity.WSBatchParam;
import com.persagy.entity.WSParam;

@WebService
@Path("/Service2_RS/")
@Produces({ "application/xml", "application/json" })
public interface IService2 {

	@WebResult
	@GET
	@Produces({ "application/xml", "application/json" })
	@Path("Get/{param}")
	public WSParam Execute(@PathParam("param") WSParam param);

	@WebResult
	@GET
	@Produces({ "application/xml", "application/json" })
	@Path("Batch/{param}")
	public WSBatchParam ExecuteBatch(@PathParam("param") WSBatchParam param);
}
