package com.persagy.service;

import javax.jws.WebResult;
import javax.jws.WebService;

import com.persagy.entity.WSBatchItem;
import com.persagy.entity.WSBatchParam;
import com.persagy.entity.WSParam;

@WebService(endpointInterface = "com.persagy.service.IService2")
public class ServiceImpl2 implements IService2 {
	@WebResult
	public WSParam Execute(WSParam param) {
		String command = param.getCommand();
		if (command.equals("data_energy")) {
			param.setDatas(ServiceUtil2.data_energy(param.getBuilding(), param.getEnergyModelSign(), param.getEnergyModelNodeSign(),
					param.getTime_period(), param.getData_time_from(), param.getData_time_to()));
		} else if (command.equals("data_service")) {
			param.setDatas(ServiceUtil2.data_service(param.getBuilding(), param.getMeter(), param.getFuncid(), param.getTime_period(),
					param.getData_time_from(), param.getData_time_to()));
		} else if (command.equals("data_near")) {
			param.setDatas(ServiceUtil2.data_near(param.getBuilding(), param.getMeter(), param.getFuncid(), param.getTime_period(),
					param.getData_time_from(), param.getData_time_to()));
		} else if (command.equals("data_near_0")) {
			param.setDatas(ServiceUtil2.data_near_0(param.getBuilding(), param.getMeter(), param.getFuncid(), param.getTime_period(),
					param.getData_time_from(), param.getData_time_to()));
		} else if (command.equals("data_near_1")) {
			param.setDatas(ServiceUtil2.data_near_1(param.getBuilding(), param.getMeter(), param.getFuncid(), param.getTime_period(),
					param.getData_time_from(), param.getData_time_to()));
		} else if (command.equals("data_near_2")) {
			param.setDatas(ServiceUtil2.data_near_2(param.getBuilding(), param.getMeter(), param.getFuncid(), param.getTime_period(),
					param.getData_time_from(), param.getData_time_to()));
		} else if (command.equals("write_fjd_2")) {
			ServiceUtil2.write_fjd_2(param);
		} else if (command.equals("present_building")) {
			ServiceUtil2.present_building(param);
		}
		return param;
	}

	@WebResult
	public WSBatchParam ExecuteBatch(WSBatchParam param) {
		String command = param.getCommand();
		if (param.getItems() != null) {
			WSBatchItem[] items = param.getItems();
			for (WSBatchItem item : items) {
				if (command.equals("data_energy")) {
					item.setDatas(ServiceUtil2.data_energy(param.getBuilding(), item.getEnergyModelSign(), item.getEnergyModelNodeSign(),
							item.getTime_period(), item.getData_time_from(), item.getData_time_to()));
				} else if (command.equals("data_service")) {
					item.setDatas(ServiceUtil2.data_service(param.getBuilding(), item.getMeter(), item.getFuncid(), item.getTime_period(),
							item.getData_time_from(), item.getData_time_to()));
				} else if (command.equals("data_near")) {
					item.setDatas(ServiceUtil2.data_near(param.getBuilding(), item.getMeter(), item.getFuncid(), item.getTime_period(),
							item.getData_time_from(), item.getData_time_to()));
				} else if (command.equals("data_near_0")) {
					item.setDatas(ServiceUtil2.data_near_0(param.getBuilding(), item.getMeter(), item.getFuncid(), item.getTime_period(),
							item.getData_time_from(), item.getData_time_to()));
				} else if (command.equals("data_near_1")) {
					item.setDatas(ServiceUtil2.data_near_1(param.getBuilding(), item.getMeter(), item.getFuncid(), item.getTime_period(),
							item.getData_time_from(), item.getData_time_to()));
				} else if (command.equals("data_near_2")) {
					item.setDatas(ServiceUtil2.data_near_2(param.getBuilding(), item.getMeter(), item.getFuncid(), item.getTime_period(),
							item.getData_time_from(), item.getData_time_to()));
				}
			}
		}
		return param;
	}
}
