package com.persagy.util;

import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.entity.Entity_ci_instance;
import com.sagacloud.util.compute_engine.entity.Entity_ci_status;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.InstanceUtil;
import com.sagacloud.util.compute_engine.util.ZKSyncUtil;
import com.zillion.util.zk.ZKWrapper;
import org.zillion.util.json.FastJsonUtil;

public class SyncUtil {
	public static void Sync(String object_sign, String instance_name) throws Exception {
		Entity_ci_instance instance = InstanceUtil.Get(ConstantCE.database_name, object_sign, instance_name);
		Entity_ci_status status = InstanceUtil.Get_status(ConstantCE.database_name, object_sign, instance_name);
		if (instance != null) {
			ZKWrapper ZK = HBaseSaveManagerRepository.randomZillionAgent().container.ZK;
			String name = instance.getObject_sign() + "_" + instance.getInstance_name();
			JSONObject instanceJSON = (JSONObject) FastJsonUtil.To_JSON(instance);

			ZKSyncUtil.Sync(ZK, ConstantCE.zk_instance + "/" + name, "true");
			long compute_interval_seconds = (Long) instanceJSON.get("compute_interval_seconds");
			ZKSyncUtil.Sync(ZK, ConstantCE.zk_compute_interval + "/" + name, ("" + compute_interval_seconds));
			ZKSyncUtil.Sync(ZK, ConstantCE.zk_status_request + "/" + name, status.getStatus_request());
		}
	}
}
