package com.persagy.wsentity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "SBuildingConfig")
public class SBuildingConfig {
	public SBuildingConfig() {

	}

	public SBuildingConfig(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String energyModelSign;
	String buildingConfigSign;

	SResearchNode[] researchNodeArray;
	SComputeUnit[] computeUnitArray;
	SEnergyModelExpression[] energyModelExpressionArray;

	public String getEnergyModelSign() {
		return energyModelSign;
	}

	public void setEnergyModelSign(String energyModelSign) {
		this.energyModelSign = energyModelSign;
	}

	public String getBuildingConfigSign() {
		return buildingConfigSign;
	}

	public void setBuildingConfigSign(String buildingConfigSign) {
		this.buildingConfigSign = buildingConfigSign;
	}

	public SResearchNode[] getResearchNodeArray() {
		return researchNodeArray;
	}

	public void setResearchNodeArray(SResearchNode[] researchNodeArray) {
		this.researchNodeArray = researchNodeArray;
	}

	public SComputeUnit[] getComputeUnitArray() {
		return computeUnitArray;
	}

	public void setComputeUnitArray(SComputeUnit[] computeUnitArray) {
		this.computeUnitArray = computeUnitArray;
	}

	public SEnergyModelExpression[] getEnergyModelExpressionArray() {
		return energyModelExpressionArray;
	}

	public void setEnergyModelExpressionArray(SEnergyModelExpression[] energyModelExpressionArray) {
		this.energyModelExpressionArray = energyModelExpressionArray;
	}
}
