package com.persagy.wsentity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "SEnergyModel")
public class SEnergyModel {
	public SEnergyModel() {

	}

	public SEnergyModel(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String energyModelSign;
	SEnergyModelNode[] nodeArray;

	public String getEnergyModelSign() {
		return energyModelSign;
	}

	public void setEnergyModelSign(String energyModelSign) {
		this.energyModelSign = energyModelSign;
	}

	public SEnergyModelNode[] getNodeArray() {
		return nodeArray;
	}

	public void setNodeArray(SEnergyModelNode[] nodeArray) {
		this.nodeArray = nodeArray;
	}
}
