package com.persagy.wsentity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "SSurveyResultItem")
public class SSurveyResultItem {
	public SSurveyResultItem() {

	}

	public SSurveyResultItem(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String buildingSign;
	String status;
	String[] problemArray;

	public String getBuildingSign() {
		return buildingSign;
	}

	public void setBuildingSign(String buildingSign) {
		this.buildingSign = buildingSign;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String[] getProblemArray() {
		return problemArray;
	}

	public void setProblemArray(String[] problemArray) {
		this.problemArray = problemArray;
	}
}
