package com.persagy.wsentity2;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "TDefaultFunctionId")
public class TDefaultFunctionId {
	public TDefaultFunctionId() {

	}

	public TDefaultFunctionId(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String energyType;
	Long funcid;

	public String getEnergyType() {
		return energyType;
	}

	public void setEnergyType(String energyType) {
		this.energyType = energyType;
	}

	public Long getFuncid() {
		return funcid;
	}

	public void setFuncid(Long funcid) {
		this.funcid = funcid;
	}
}
