package com.persagy.wsentity2;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "TEnergyModel")
public class TEnergyModel {
	public TEnergyModel() {

	}

	public TEnergyModel(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String sign;
	String name;
	String buildingSign;
	String energyType;
	TEnergyItem[] energyItemArray;

	public String getSign() {
		return sign;
	}

	public void setSign(String sign) {
		this.sign = sign;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getBuildingSign() {
		return buildingSign;
	}

	public void setBuildingSign(String buildingSign) {
		this.buildingSign = buildingSign;
	}

	public String getEnergyType() {
		return energyType;
	}

	public void setEnergyType(String energyType) {
		this.energyType = energyType;
	}

	public TEnergyItem[] getEnergyItemArray() {
		return energyItemArray;
	}

	public void setEnergyItemArray(TEnergyItem[] energyItemArray) {
		this.energyItemArray = energyItemArray;
	}
}
