package com.persagy.wsentity2;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "TSurvey")
public class TSurvey {
	public TSurvey() {

	}

	public TSurvey(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	TDefaultFunctionId[] defaultFunctionIdArray;

	String projectSign;
	TMeter[] reportMeterArray;
	TBranch[] branchArray;
	TEnergyModel[] energyModelArray;
	TCalculateUnit[] calculateUnitArray;
	TConfigUse[] configUseArray;

	TMeter[] pointArray;

	public TDefaultFunctionId[] getDefaultFunctionIdArray() {
		return defaultFunctionIdArray;
	}

	public void setDefaultFunctionIdArray(TDefaultFunctionId[] defaultFunctionIdArray) {
		this.defaultFunctionIdArray = defaultFunctionIdArray;
	}

	public String getProjectSign() {
		return projectSign;
	}

	public void setProjectSign(String projectSign) {
		this.projectSign = projectSign;
	}

	public TMeter[] getReportMeterArray() {
		return reportMeterArray;
	}

	public void setReportMeterArray(TMeter[] reportMeterArray) {
		this.reportMeterArray = reportMeterArray;
	}

	public TBranch[] getBranchArray() {
		return branchArray;
	}

	public void setBranchArray(TBranch[] branchArray) {
		this.branchArray = branchArray;
	}

	public TEnergyModel[] getEnergyModelArray() {
		return energyModelArray;
	}

	public void setEnergyModelArray(TEnergyModel[] energyModelArray) {
		this.energyModelArray = energyModelArray;
	}

	public TCalculateUnit[] getCalculateUnitArray() {
		return calculateUnitArray;
	}

	public void setCalculateUnitArray(TCalculateUnit[] calculateUnitArray) {
		this.calculateUnitArray = calculateUnitArray;
	}

	public TConfigUse[] getConfigUseArray() {
		return configUseArray;
	}

	public void setConfigUseArray(TConfigUse[] configUseArray) {
		this.configUseArray = configUseArray;
	}

	public TMeter[] getPointArray() {
		return pointArray;
	}

	public void setPointArray(TMeter[] pointArray) {
		this.pointArray = pointArray;
	}

}
