// $ANTLR 3.1 ..\\antlrEMSIV\\src\\EMSScanner.g 2015-12-04 17:45:01

package com.pbsage.parser.emsiv;

import java.util.Map;
import java.util.HashMap;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class EMSScanner extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "NEWLINE", "NUMBER", "ID", "F1", "F2", "'+'", "'-'", "'*'", "'/'", "'('", "')'", "','"
    };
    public static final int T__15=15;
    public static final int NEWLINE=4;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int T__10=10;
    public static final int NUMBER=5;
    public static final int F1=7;
    public static final int F2=8;
    public static final int ID=6;
    public static final int EOF=-1;
    public static final int T__9=9;

    // delegates
    // delegators


        public EMSScanner(TreeNodeStream input) {
            this(input, new RecognizerSharedState());
        }
        public EMSScanner(TreeNodeStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return EMSScanner.tokenNames; }
    public String getGrammarFileName() { return "..\\antlrEMSIV\\src\\EMSScanner.g"; }


    	Map<String, String> varDict = new HashMap<String, String>();
    	
    	private String GetRealVar(String var)
    	{
    		return var.substring(1, var.length()-1);
    	}

    	private void AddVar(String var)
    	{	
    		if(!this.varDict.containsKey(var))
    		{
    			this.varDict.put(var,null);
    		}
    	}
    	
    	public Map<String, String> GetVarDict()
    	{
    		return varDict; 
    	}



    // $ANTLR start "prog"
    // ..\\antlrEMSIV\\src\\EMSScanner.g:37:1: prog : expr ;
    public final void prog() throws RecognitionException {
        try {
            // ..\\antlrEMSIV\\src\\EMSScanner.g:38:2: ( expr )
            // ..\\antlrEMSIV\\src\\EMSScanner.g:38:4: expr
            {
            pushFollow(FOLLOW_expr_in_prog48);
            expr();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "prog"


    // $ANTLR start "expr"
    // ..\\antlrEMSIV\\src\\EMSScanner.g:41:1: expr : ( ^( '+' expr expr ) | ^( '-' expr expr ) | ^( '*' expr expr ) | ^( '/' expr expr ) | ID | NUMBER | ^( F1 expr ) | ^( F2 expr expr ) );
    public final void expr() throws RecognitionException {
        CommonTree ID1=null;

        try {
            // ..\\antlrEMSIV\\src\\EMSScanner.g:42:2: ( ^( '+' expr expr ) | ^( '-' expr expr ) | ^( '*' expr expr ) | ^( '/' expr expr ) | ID | NUMBER | ^( F1 expr ) | ^( F2 expr expr ) )
            int alt1=8;
            switch ( input.LA(1) ) {
            case 9:
                {
                alt1=1;
                }
                break;
            case 10:
                {
                alt1=2;
                }
                break;
            case 11:
                {
                alt1=3;
                }
                break;
            case 12:
                {
                alt1=4;
                }
                break;
            case ID:
                {
                alt1=5;
                }
                break;
            case NUMBER:
                {
                alt1=6;
                }
                break;
            case F1:
                {
                alt1=7;
                }
                break;
            case F2:
                {
                alt1=8;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }

            switch (alt1) {
                case 1 :
                    // ..\\antlrEMSIV\\src\\EMSScanner.g:42:4: ^( '+' expr expr )
                    {
                    match(input,9,FOLLOW_9_in_expr60); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr62);
                    expr();

                    state._fsp--;

                    pushFollow(FOLLOW_expr_in_expr64);
                    expr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 2 :
                    // ..\\antlrEMSIV\\src\\EMSScanner.g:43:4: ^( '-' expr expr )
                    {
                    match(input,10,FOLLOW_10_in_expr71); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr73);
                    expr();

                    state._fsp--;

                    pushFollow(FOLLOW_expr_in_expr75);
                    expr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 3 :
                    // ..\\antlrEMSIV\\src\\EMSScanner.g:44:4: ^( '*' expr expr )
                    {
                    match(input,11,FOLLOW_11_in_expr84); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr86);
                    expr();

                    state._fsp--;

                    pushFollow(FOLLOW_expr_in_expr88);
                    expr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 4 :
                    // ..\\antlrEMSIV\\src\\EMSScanner.g:45:4: ^( '/' expr expr )
                    {
                    match(input,12,FOLLOW_12_in_expr95); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr97);
                    expr();

                    state._fsp--;

                    pushFollow(FOLLOW_expr_in_expr99);
                    expr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 5 :
                    // ..\\antlrEMSIV\\src\\EMSScanner.g:46:4: ID
                    {
                    ID1=(CommonTree)match(input,ID,FOLLOW_ID_in_expr105); 
                    this.AddVar(this.GetRealVar((ID1!=null?ID1.getText():null)));

                    }
                    break;
                case 6 :
                    // ..\\antlrEMSIV\\src\\EMSScanner.g:47:4: NUMBER
                    {
                    match(input,NUMBER,FOLLOW_NUMBER_in_expr112); 

                    }
                    break;
                case 7 :
                    // ..\\antlrEMSIV\\src\\EMSScanner.g:48:4: ^( F1 expr )
                    {
                    match(input,F1,FOLLOW_F1_in_expr118); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr120);
                    expr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;
                case 8 :
                    // ..\\antlrEMSIV\\src\\EMSScanner.g:49:4: ^( F2 expr expr )
                    {
                    match(input,F2,FOLLOW_F2_in_expr127); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr129);
                    expr();

                    state._fsp--;

                    pushFollow(FOLLOW_expr_in_expr131);
                    expr();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "expr"

    // Delegated rules


 

    public static final BitSet FOLLOW_expr_in_prog48 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_9_in_expr60 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr62 = new BitSet(new long[]{0x0000000000001FE0L});
    public static final BitSet FOLLOW_expr_in_expr64 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_10_in_expr71 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr73 = new BitSet(new long[]{0x0000000000001FE0L});
    public static final BitSet FOLLOW_expr_in_expr75 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_11_in_expr84 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr86 = new BitSet(new long[]{0x0000000000001FE0L});
    public static final BitSet FOLLOW_expr_in_expr88 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_12_in_expr95 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr97 = new BitSet(new long[]{0x0000000000001FE0L});
    public static final BitSet FOLLOW_expr_in_expr99 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ID_in_expr105 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NUMBER_in_expr112 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_F1_in_expr118 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr120 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_F2_in_expr127 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr129 = new BitSet(new long[]{0x0000000000001FE0L});
    public static final BitSet FOLLOW_expr_in_expr131 = new BitSet(new long[]{0x0000000000000008L});

}