package com.persagy.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "WSData_fjd_2")
public class WSData_fjd_2 {
	public WSData_fjd_2() {

	}

	public WSData_fjd_2(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String data_time;
	Long data_flag;
	String time_period;
	Double data_value;

	public String getData_time() {
		return data_time;
	}

	public void setData_time(String data_time) {
		this.data_time = data_time;
	}

	public Long getData_flag() {
		return data_flag;
	}

	public void setData_flag(Long data_flag) {
		this.data_flag = data_flag;
	}

	public String getTime_period() {
		return time_period;
	}

	public void setTime_period(String time_period) {
		this.time_period = time_period;
	}

	public Double getData_value() {
		return data_value;
	}

	public void setData_value(Double data_value) {
		this.data_value = data_value;
	}
}
