package com.persagy.entity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "WSEntity_fjd_1")
public class WSEntity_fjd_1 {
	public WSEntity_fjd_1() {

	}

	public WSEntity_fjd_1(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String building;
	Long compute_round;
	String compute_time_from;
	String compute_time_to;
	Long fjd_compute_round_from;
	Long fjd_compute_round_to;
	Long is_finished;

	public String getBuilding() {
		return building;
	}

	public void setBuilding(String building) {
		this.building = building;
	}

	public Long getCompute_round() {
		return compute_round;
	}

	public void setCompute_round(Long compute_round) {
		this.compute_round = compute_round;
	}

	public String getCompute_time_from() {
		return compute_time_from;
	}

	public void setCompute_time_from(String compute_time_from) {
		this.compute_time_from = compute_time_from;
	}

	public String getCompute_time_to() {
		return compute_time_to;
	}

	public void setCompute_time_to(String compute_time_to) {
		this.compute_time_to = compute_time_to;
	}

	public Long getFjd_compute_round_from() {
		return fjd_compute_round_from;
	}

	public void setFjd_compute_round_from(Long fjd_compute_round_from) {
		this.fjd_compute_round_from = fjd_compute_round_from;
	}

	public Long getFjd_compute_round_to() {
		return fjd_compute_round_to;
	}

	public void setFjd_compute_round_to(Long fjd_compute_round_to) {
		this.fjd_compute_round_to = fjd_compute_round_to;
	}

	public Long getIs_finished() {
		return is_finished;
	}

	public void setIs_finished(Long is_finished) {
		this.is_finished = is_finished;
	}

}
