package com.persagy.entity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "WSFlag")
public class WSFlag {
	public WSFlag() {

	}

	public WSFlag(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String data_time;
	Long rely_flag;

	public String getData_time() {
		return data_time;
	}

	public void setData_time(String data_time) {
		this.data_time = data_time;
	}

	public Long getRely_flag() {
		return rely_flag;
	}

	public void setRely_flag(Long rely_flag) {
		this.rely_flag = rely_flag;
	}
}
