package com.persagy.entity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "WSParam")
public class WSParam {
	public WSParam() {

	}

	public WSParam(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	// param items
	String command;
	String status;
	String building;// command=list_point/data_near/flag_near/data_energy/begin_fjd_1/read_fjd_1/write_fjd_1/end_fjd_1/begin_fjd_flag/write_fjd_flag/end_fjd_flag
	Long compute_round;// read_fjd_1/write_fjd_1/end_fjd_1/write_fjd_flag/end_fjd_flag
	String meter;// command=data_near/flag_near/read_fjd_1/write_fjd_1/write_fjd_flag
	Long funcid;// command=data_near/flag_near/read_fjd_1/write_fjd_1/write_fjd_flag
	String energyModelSign;// command=data_energy
	String energyModelNodeSign;// command=data_energy
	String time_period;// command=data_near/flag_near/data_energy
	String data_time_from;// command=data_near/flag_near/data_energy/begin_fjd_flag
	String data_time_to;// command=data_near/flag_near/data_energy/begin_fjd_flag
	WSData_fjd_1[] datas_fjd_1;// command=write_fjd_1
	WSData_fjd_2[] datas_fjd_2;// command=write_fjd_2
	WSFlag[] flags;// command=flag_near/write_fjd_flag

	// return items
	String[] buildings;// command=list_building
	WSPoint[] points;// command=list_point/read_fjd_1
	WSData[] datas;// command=data_near/data_energy
	WSBuildingData[] buildingdatas;
	WSEntity_fjd_1 fjd_1;// command=begin_fjd_1

	public String getCommand() {
		return command;
	}

	public void setCommand(String command) {
		this.command = command;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String getBuilding() {
		return building;
	}

	public void setBuilding(String building) {
		this.building = building;
	}

	public Long getCompute_round() {
		return compute_round;
	}

	public void setCompute_round(Long compute_round) {
		this.compute_round = compute_round;
	}

	public String getMeter() {
		return meter;
	}

	public void setMeter(String meter) {
		this.meter = meter;
	}

	public Long getFuncid() {
		return funcid;
	}

	public void setFuncid(Long funcid) {
		this.funcid = funcid;
	}

	public String getEnergyModelSign() {
		return energyModelSign;
	}

	public void setEnergyModelSign(String energyModelSign) {
		this.energyModelSign = energyModelSign;
	}

	public String getEnergyModelNodeSign() {
		return energyModelNodeSign;
	}

	public void setEnergyModelNodeSign(String energyModelNodeSign) {
		this.energyModelNodeSign = energyModelNodeSign;
	}

	public String getTime_period() {
		return time_period;
	}

	public void setTime_period(String time_period) {
		this.time_period = time_period;
	}

	public String getData_time_from() {
		return data_time_from;
	}

	public void setData_time_from(String data_time_from) {
		this.data_time_from = data_time_from;
	}

	public String getData_time_to() {
		return data_time_to;
	}

	public void setData_time_to(String data_time_to) {
		this.data_time_to = data_time_to;
	}

	public WSData_fjd_1[] getDatas_fjd_1() {
		return datas_fjd_1;
	}

	public void setDatas_fjd_1(WSData_fjd_1[] datas_fjd_1) {
		this.datas_fjd_1 = datas_fjd_1;
	}

	public WSData_fjd_2[] getDatas_fjd_2() {
		return datas_fjd_2;
	}

	public void setDatas_fjd_2(WSData_fjd_2[] datas_fjd_2) {
		this.datas_fjd_2 = datas_fjd_2;
	}

	public WSFlag[] getFlags() {
		return flags;
	}

	public void setFlags(WSFlag[] flags) {
		this.flags = flags;
	}

	public String[] getBuildings() {
		return buildings;
	}

	public void setBuildings(String[] buildings) {
		this.buildings = buildings;
	}

	public WSPoint[] getPoints() {
		return points;
	}

	public void setPoints(WSPoint[] points) {
		this.points = points;
	}

	public WSData[] getDatas() {
		return datas;
	}

	public void setDatas(WSData[] datas) {
		this.datas = datas;
	}

	public WSBuildingData[] getBuildingdatas() {
		return buildingdatas;
	}

	public void setBuildingdatas(WSBuildingData[] buildingdatas) {
		this.buildingdatas = buildingdatas;
	}

	public WSEntity_fjd_1 getFjd_1() {
		return fjd_1;
	}

	public void setFjd_1(WSEntity_fjd_1 fjd_1) {
		this.fjd_1 = fjd_1;
	}
}
