package com.persagy.wsentity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "SBuilding")
public class SBuilding {
	public SBuilding() {

	}

	public SBuilding(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String buildingSign;
	String dataDensity;
	SEnergyModel[] energyModelArray;
	SBuildingConfig[] buildingConfigArray;
	SBuildingConfigUse[] buildingConfigUseArray;

	public String getBuildingSign() {
		return buildingSign;
	}

	public void setBuildingSign(String buildingSign) {
		this.buildingSign = buildingSign;
	}

	public String getDataDensity() {
		return dataDensity;
	}

	public void setDataDensity(String dataDensity) {
		this.dataDensity = dataDensity;
	}

	public SEnergyModel[] getEnergyModelArray() {
		return energyModelArray;
	}

	public void setEnergyModelArray(SEnergyModel[] energyModelArray) {
		this.energyModelArray = energyModelArray;
	}

	public SBuildingConfig[] getBuildingConfigArray() {
		return buildingConfigArray;
	}

	public void setBuildingConfigArray(SBuildingConfig[] buildingConfigArray) {
		this.buildingConfigArray = buildingConfigArray;
	}

	public SBuildingConfigUse[] getBuildingConfigUseArray() {
		return buildingConfigUseArray;
	}

	public void setBuildingConfigUseArray(SBuildingConfigUse[] buildingConfigUseArray) {
		this.buildingConfigUseArray = buildingConfigUseArray;
	}
}
