package com.persagy.wsentity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "SBuildingConfigUse")
public class SBuildingConfigUse {
	public SBuildingConfigUse() {

	}

	public SBuildingConfigUse(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String energyModelSign;
	String bcuseFrom;
	String bcuseTo;
	String buildingConfigSign;

	public String getEnergyModelSign() {
		return energyModelSign;
	}

	public void setEnergyModelSign(String energyModelSign) {
		this.energyModelSign = energyModelSign;
	}

	public String getBcuseFrom() {
		return bcuseFrom;
	}

	public void setBcuseFrom(String bcuseFrom) {
		this.bcuseFrom = bcuseFrom;
	}

	public String getBcuseTo() {
		return bcuseTo;
	}

	public void setBcuseTo(String bcuseTo) {
		this.bcuseTo = bcuseTo;
	}

	public String getBuildingConfigSign() {
		return buildingConfigSign;
	}

	public void setBuildingConfigSign(String buildingConfigSign) {
		this.buildingConfigSign = buildingConfigSign;
	}
}
