package com.persagy.wsentity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "SResearchNode")
public class SResearchNode {
	public SResearchNode() {

	}

	public SResearchNode(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String sign;
	String name;
	String parentSign;
	String isComputeUnit;
	String energyModelNodeSign;
	String meter;

	public String getSign() {
		return sign;
	}

	public void setSign(String sign) {
		this.sign = sign;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getParentSign() {
		return parentSign;
	}

	public void setParentSign(String parentSign) {
		this.parentSign = parentSign;
	}

	public String getIsComputeUnit() {
		return isComputeUnit;
	}

	public void setIsComputeUnit(String isComputeUnit) {
		this.isComputeUnit = isComputeUnit;
	}

	public String getEnergyModelNodeSign() {
		return energyModelNodeSign;
	}

	public void setEnergyModelNodeSign(String energyModelNodeSign) {
		this.energyModelNodeSign = energyModelNodeSign;
	}

	public String getMeter() {
		return meter;
	}

	public void setMeter(String meter) {
		this.meter = meter;
	}
}
