package com.persagy.wsentity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "SSurvey")
public class SSurvey {
	public SSurvey() {

	}

	public SSurvey(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String projectSign;
	SMeter[] meterArray;
	SBuilding[] buildingArray;

	public String getProjectSign() {
		return projectSign;
	}

	public void setProjectSign(String projectSign) {
		this.projectSign = projectSign;
	}

	public SMeter[] getMeterArray() {
		return meterArray;
	}

	public void setMeterArray(SMeter[] meterArray) {
		this.meterArray = meterArray;
	}

	public SBuilding[] getBuildingArray() {
		return buildingArray;
	}

	public void setBuildingArray(SBuilding[] buildingArray) {
		this.buildingArray = buildingArray;
	}
}
