package com.persagy.wsentity;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "SSurvey")
public class SSurveyResult {
	public SSurveyResult() {

	}

	public SSurveyResult(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String projectSign;
	SSurveyResultItem[] itemArray;

	public String getProjectSign() {
		return projectSign;
	}

	public void setProjectSign(String projectSign) {
		this.projectSign = projectSign;
	}

	public SSurveyResultItem[] getItemArray() {
		return itemArray;
	}

	public void setItemArray(SSurveyResultItem[] itemArray) {
		this.itemArray = itemArray;
	}
}
