package com.persagy.wsentity2;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "TCalculateUnit")
public class TCalculateUnit {
	public TCalculateUnit() {

	}

	public TCalculateUnit(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String sign;
	String name;
	TCalculateUnit2EnergyItem[] calculateUnit2EnergyItemArray;

	public String getSign() {
		return sign;
	}

	public void setSign(String sign) {
		this.sign = sign;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public TCalculateUnit2EnergyItem[] getCalculateUnit2EnergyItemArray() {
		return calculateUnit2EnergyItemArray;
	}

	public void setCalculateUnit2EnergyItemArray(TCalculateUnit2EnergyItem[] calculateUnit2EnergyItemArray) {
		this.calculateUnit2EnergyItemArray = calculateUnit2EnergyItemArray;
	}
}
