package com.persagy.wsentity2;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "TCalculateUnit2EnergyItem")
public class TCalculateUnit2EnergyItem {
	public TCalculateUnit2EnergyItem() {

	}

	public TCalculateUnit2EnergyItem(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String energyModelSign;
	String energyItemSign;

	public String getEnergyModelSign() {
		return energyModelSign;
	}

	public void setEnergyModelSign(String energyModelSign) {
		this.energyModelSign = energyModelSign;
	}

	public String getEnergyItemSign() {
		return energyItemSign;
	}

	public void setEnergyItemSign(String energyItemSign) {
		this.energyItemSign = energyItemSign;
	}
}
