package com.persagy.wsentity2;

import javax.xml.bind.annotation.XmlRootElement;

import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
@Slf4j
@XmlRootElement(name = "TConfigUseItem")
public class TConfigUseItem {
	public TConfigUseItem() {

	}

	public TConfigUseItem(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String branchSign;
	String parentSign;
	String meterSign;
	Double meterCT;
	String formula;
	String energyModelSign;
	String energyItemSign;
	String calculateUnitSign;

	public String getBranchSign() {
		return branchSign;
	}

	public void setBranchSign(String branchSign) {
		this.branchSign = branchSign;
	}

	public String getParentSign() {
		return parentSign;
	}

	public void setParentSign(String parentSign) {
		this.parentSign = parentSign;
	}

	public String getMeterSign() {
		return meterSign;
	}

	public void setMeterSign(String meterSign) {
		this.meterSign = meterSign;
	}

	public Double getMeterCT() {
		return meterCT;
	}

	public void setMeterCT(Double meterCT) {
		this.meterCT = meterCT;
	}

	public String getFormula() {
		return formula;
	}

	public void setFormula(String formula) {
		this.formula = formula;
	}

	public String getEnergyModelSign() {
		return energyModelSign;
	}

	public void setEnergyModelSign(String energyModelSign) {
		this.energyModelSign = energyModelSign;
	}

	public String getEnergyItemSign() {
		return energyItemSign;
	}

	public void setEnergyItemSign(String energyItemSign) {
		this.energyItemSign = energyItemSign;
	}

	public String getCalculateUnitSign() {
		return calculateUnitSign;
	}

	public void setCalculateUnitSign(String calculateUnitSign) {
		this.calculateUnitSign = calculateUnitSign;
	}
}
