package com.persagy.wsentity2;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.zillion.util.json.FastJsonUtil;

import javax.xml.bind.annotation.XmlRootElement;
@Slf4j
@XmlRootElement(name = "TSurveyResult")
public class TSurveyResult {
	public TSurveyResult() {

	}

	public TSurveyResult(String str) {
		try {
			JSONObject json = (JSONObject) JSON.parse(str);
			FastJsonUtil.Set_JavaObject(json, this);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

	String projectSign;
	String status;
	String[] problemArray;

	public String getProjectSign() {
		return projectSign;
	}

	public void setProjectSign(String projectSign) {
		this.projectSign = projectSign;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String[] getProblemArray() {
		return problemArray;
	}

	public void setProblemArray(String[] problemArray) {
		this.problemArray = problemArray;
	}
}
