package com.persagy.service;

import java.io.File;

import org.apache.cxf.aegis.databinding.AegisDatabinding;
import org.apache.cxf.frontend.ClientProxyFactoryBean;
import org.apache.cxf.jaxws.support.JaxWsServiceFactoryBean;
import org.zillion.util.json.FastJsonReaderUtil;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSONObject;
import com.persagy.entity.WSEntity_tenants;

public class ClientTest_tenant {

	public static void main(String[] args) throws Exception {
		String src = "[1001]+[1001.0]";
		src = src.replaceAll("\\[1001\\]", "a");
		src = src.replaceAll("\\[1001\\.0\\]", "b");
		System.out.println(src);

		ClientProxyFactoryBean factory = new ClientProxyFactoryBean();
		factory.setServiceClass(IServiceTenant.class);
		factory.setAddress("http://localhost:8080/compute-engine-webapp/services/ServiceTenant_WS");
		factory.setServiceFactory(new JaxWsServiceFactoryBean());
		factory.getServiceFactory().setDataBinding(new AegisDatabinding());
		IServiceTenant client = (IServiceTenant) factory.create();

		client.AddTenants(generate_String("tenants.json"));

		client.ModifyTenantPrice(generate_String("tenant_modify_price.json"));
	}

	static String generate_String(String filename) throws Exception {
		JSONObject json = FastJsonReaderUtil.Instance()
				.ReadJSONObject(new File("D:\\Work\\Saga_Project_Compute\\compute-engine-webapp\\src\\main\\resources\\" + filename));
		return json.toJSONString();
	}

	static WSEntity_tenants generate() throws Exception {
		WSEntity_tenants result;

		JSONObject json = FastJsonReaderUtil.Instance()
				.ReadJSONObject(new File("D:\\Work\\Saga_Project_Compute\\compute-engine-webapp\\src\\main\\resources\\tenants.json"));
		// result = (SSurvey) FastJsonUtil.To_JavaObject(Convertor_JSON.FastJson2SagaJson(json), TSurvey.class);
		result = (WSEntity_tenants) FastJsonUtil.To_JavaObject(json, WSEntity_tenants.class);

		return result;
	}
}
